package com.gigaspaces.test;

import com.gigaspaces.annotation.pojo.SpaceId;
import com.gigaspaces.annotation.pojo.SpaceIndex;
import com.gigaspaces.metadata.index.SpaceIndexType;
import com.j_spaces.core.client.SQLQuery;
import org.openspaces.core.GigaSpace;
import org.openspaces.core.GigaSpaceConfigurer;
import org.openspaces.core.space.EmbeddedSpaceConfigurer;

import java.util.stream.LongStream;


public class IndexSqlBug {
    
    public static void main(String[] args) {
        GigaSpace gigaSpace = new GigaSpaceConfigurer(new EmbeddedSpaceConfigurer("test")).gigaSpace();
        LongStream.range(0, 100).forEach(i -> {
            gigaSpace.write(new FooWithIndex(i, "Foo"+i));
            gigaSpace.write(new FooWithoutIndex(i, "Foo"+i));
        });
        
        System.out.println(gigaSpace.count(new SQLQuery<>(FooWithIndex.class, "LOWER(field) = 'foo3'")));
        System.out.println(gigaSpace.count(new SQLQuery<>(FooWithIndex.class, "UPPER(field) = 'FOO3'")));
        System.out.println(gigaSpace.count(new SQLQuery<>(FooWithIndex.class, "CHAR_LENGTH(field) = 4")));
        System.out.println(gigaSpace.count(new SQLQuery<>(FooWithoutIndex.class, "LOWER(field) = 'foo3'")));
        System.out.println(gigaSpace.count(new SQLQuery<>(FooWithoutIndex.class, "UPPER(field) = 'FOO3'")));
        System.out.println(gigaSpace.count(new SQLQuery<>(FooWithoutIndex.class, "CHAR_LENGTH(field) = 4")));
        System.exit(0);
    }
    
    static class FooWithIndex {
        private Long id;
        private String field;
        
        private FooWithIndex() {
        }
        
        public FooWithIndex(Long id, String field) {
            this.id = id;
            this.field = field;
        }
        
        @SpaceId
        public Long getId() {
            return id;
        }
        
        public void setId(Long id) {
            this.id = id;
        }
    
        @SpaceIndex
        public String getField() {
            return field;
        }
        
        public void setField(String field) {
            this.field = field;
        }
    }
    
    static class FooWithoutIndex {
        private Long id;
        private String field;
        
        private FooWithoutIndex() {
        }
        
        public FooWithoutIndex(Long id, String field) {
            this.id = id;
            this.field = field;
        }
        
        @SpaceId
        public Long getId() {
            return id;
        }
        
        public void setId(Long id) {
            this.id = id;
        }
        
        public String getField() {
            return field;
        }
        
        public void setField(String field) {
            this.field = field;
        }
    }
}